package gggt.eg;

import java.io.*;

import gggt.eg.set.*;

/**
* Main App class.
*/
public class App {

	private static SettingParser sp;
	private static Setting set;
	private static Engine eg;

	/** To check the string array. */
	private static boolean check(String[] tab) {
		if(tab != null) {
			for(int i=0;i<tab.length;i++)
				if(tab[i] == null)
					return false;
			return true;
			}
		return false;
		}

	/** Test if the string parametter is a file or directory. */
	private static boolean onDrive(String fName) {
		if(fName!=null)
			return new File(fName).exists();
		return false;
		}

	/** Test if the parametter is a valid command. */
	private static boolean isCommand(String p) {
		if(p!=null)
			for(int i=0;i<ps.length;i++)
				if(p.equals(ps[i]))
					return true;
		return false;
		}
	private static final String[] ps = {"-px","-gt"};

	/** To process a document. */
	public static void process(String sName,String mode) {
		if((sName != null)&(mode != null)) {
			if(mode.equals("-px")) {
				sp = new SettingParser();
				set = sp.parse(sName);
				set.print();
				}
			else if(mode.equals("-gt")) {
				eg = new Engine();
				sp = new SettingParser();
				set = sp.parse(sName);
				System.out.println(eg.build(set));
				}
			}
		}

	/** To process a document. */
	public static void process(String sName,String gName,String mName,String mode) {
		if((sName != null)&(gName != null)&(mName!=null)&(mode!=null)) {
			if(mode.equals("-px")) {
				sp = new SettingParser();
				set = sp.parse(sName,gName,mName);
				set.print();
				}
			else if(mode.equals("-gt")) {
				eg = new Engine();
				sp = new SettingParser();
				set = sp.parse(sName,gName,mName);
				System.out.println(eg.build(set));
				}
			}
		}

	/** Exit method. */
	private static void exit() {
		System.out.println("bad settings, do:");
		System.out.println("\t java -jar 3gT.jar name -o");
		System.out.println("name is an xml setting file");
		System.out.println
				(
				"o is:\n"
				+"\t px \t parse and print the xml setting file\n"
				+"\t gt \t produce the groundthruth (default mode)\n"
				);
		System.out.println("or:");
		System.out.println("\t java -jar 3gT.jar name grounds models -o");
		System.out.println("name is an xml setting file");
		System.out.println("grounds is the ground directory");
		System.out.println("models is the model directory");
		System.out.println
				(
				"o is:\n"
				+"\t px \t parse and print the xml setting file\n"
				+"\t gt \t produce the groundthruth (default mode)\n"
				);
		System.exit(0);
		}

	/**
	* The Main method.
	*/
	public static void main(String args[]) throws Exception {
		if(check(args)) {
			if(args.length == 2) {
				if	(
					onDrive(args[0])
					&
					isCommand(args[1])
					)
					process(args[0],args[1]);
				else
					exit();
				}
			else if(args.length == 4) {
				if	(
					onDrive(args[0])
					&
					onDrive(args[1])
					&
					onDrive(args[2])
					&
					isCommand(args[3])
					)
					process(args[0],args[1],args[2],args[3]);
				else
					exit();
				}
			else
				exit();
			}
		else
			exit();
		}

	}
