package gggt.eg;

import java.io.*;

import gom.*;
import gom.lrw.*;

import gggt.eg.set.*;
import gggt.eg.bui.*;

/**
* Engine class.
*/
public class Engine {

	private SettingParser sp;
	private Setting set;
	private Build b;
	private Map map;

	/** Default constructor. */
	public Engine()
		{ sp = new SettingParser(); }

	/** To build a single file . */
	public void build(String sName, String fName) {
		if((sName!=null)&(fName != null))
			if(new File(sName).isFile()) {
				set = sp.parse(sName);
				if(set != null) {
					b = new Build(); b.init(set);
					b.build(); map = set.getMap();
					Write.svgWrite	(
									b.getDoc(),
									map.getWidth(),
									map.getHeight(),
									merge("file:/",map.getGround()),
									fName
									);
					}
				}
		}
	private String merge(String s1,String s2) {
		if((s1 != null)&(s2 !=null))
			return new String(s1+s2);
		return null;
		}

	/** To build the database from a setting file name. */
	public String build(String sName) {
		if(sName != null)
			if(new File(sName).isFile())
				return build(sp.parse(sName));
		return null;
		}

	/** To build the database from a setting object. */
	public String build(Setting set) {
		if(set != null) {
			b = new Build(); b.init(set); aq = 0;
			bName = baseCreate(set.getPath());
			fileExport(set.getPath(),bName);
			map = set.getMap(); gName = fileExport(map.getGround(),bName);
			for(int i=0; i<set.getSize() ; i++) {
				b.build();  aq += b.getQ();
				docWrite(b.getDoc(),map.getWidth(),map.getHeight(),gName,bName,i);
				}
			System.out.println("building factor: "+(aq/(double)set.getSize())+"%");
			return bName;
			}
		return null;
		}
	private String bName,gName; double aq;

	/** To create the directory database. */
	
	private String baseCreate(String sPath) {
		if(sPath != null) {
			String rName = sPath;
			if(rName.toLowerCase().endsWith(".xml"))
				rName = rName.substring(0,rName.length()-4);
			int i=0; String bName = null;
			do
				{ bName = rName+"_"+String.valueOf(i)+"/"; i++; }
			while(new File(bName).exists());
			new File(bName).mkdir();
			return bName;
			}
		return null;
		}
	
	/** To export a file. */

	private String fileExport(String fName, String dName) {
		if((fName!=null)&(dName!=null))
			if(new File(fName).isFile() & new File(dName).isDirectory()) {
				String name = new File(fName).getName();
				try {
					in = new FileInputStream(fName);
					buf = new byte[in.available()];
					in.read(buf);
            		in.close();
					out = new FileOutputStream(dName+"/"+name);
            		out.write(buf);
            		out.close();
					}
				catch(Exception e)
					{}
				return name;
				}
		return null;
		}
	private FileInputStream in;
	private byte[] buf;
	private FileOutputStream out;
	
	/** To write a document. */
	private void docWrite(OHL doc, double width, double height, String gName, String bName, int i) {
		if((doc != null)&(width>0)&(height>0)&(bName!=null)&(i>=0)) {
			si = String.valueOf(i);
			Write.svgWrite(doc,width,height,gName,bName + "file_" + si + ".svg");
			Write.gomWrite(doc,bName + "file_" + si + ".gom");
			Write.xmlWrite(doc,bName + "file_" + si + ".xml");
			System.out.println("file_" + si);
			}
		}
	private String si;

	}
