package gggt.eg.dst;

import gom.*;

/**
*  Class to add vectorial distortion
*/
public class Distort extends Gaussian {

	private static final long serialVersionUID = 1;
	
	private boolean resize, rotate, move;
	private OHL set;

	/** Default constructor. */
	public Distort(boolean resize,boolean rotate, boolean move, double variance) {
		super(variance);
		this.resize = resize; this.rotate = rotate; this.move = move; set = null;
		}

	/** To convert the graphical object to a simple set of vector. */
	private void toSet(OGraphic o) {
		if(o != null)
			if(o instanceof OContainer) {
				q = ((OContainer)o).query(gNames,false);
				set = new OHL(); set.addObj(q);
				}
		}
	private OGraphic[] q;
	private String[] gNames = {"gom.OHL","gom.OGraph"};

	/** Main method for vectorial distortion. */
	private void distortion() {
		for(int i=0;i<set.objSize();i++) {
			o = set.getObj(i);
			if(resize)
				resizeDistortion();
			if(rotate)
				rotateDistortion();
			if(move)
				moveDistortion();
			}
		}
	private OGraphic o; private double s;

	/** Scale distortion. */
	private void resizeDistortion() {
		s = nextValue();
		if (s<0) {
			r = 1 / (1 - s);
			o.resize(r);
			}
		else if (s>0) {
			r = 1 + s;
			o.resize(r);
			}
		}
	private double r;

	/** Rotate distortion. */
	private void rotateDistortion() {
		s = nextValue();
		o.rotate(s,o.gravity());
		}

	/** Move distortion. */
	private void moveDistortion() {
		s = nextValue(); bb = o.boundingBox();
		dx = bb[2]*s; dy = bb[3]*s;
		o.move(dx,dy);
		}
	private double[] bb; private double dx,dy;

	/** Main method. */
	public void process(OGraphic o) {
		toSet(o);
		distortion();
		}

	}


