package gggt.eg.set;

import java.io.*;

import gom.std.*;

/**
* The Maps class corresponds to the maps tag
* into the setting file.
*/
public class Map extends StringTo {

	private double scale;				// background scaling
	private double width, height; 		// features of maps
	private int size;					// number of object
	private String ground;				// url of the image background

	/** Default constructor. */
	Map()
		{ scale = 1.0; width = 512; height = 512; size = 1;  ground = null; }

	/** To get the scale. */
	public double getScale()
		{return scale;}
	void setScale(String v) {
		if(v != null)
			if((sc = getDouble(v)) > 0)
				scale = sc;
		}
	private double sc;

	public void setScale(double v) {
		if((v>0)&(v!=1))
			scale = v;
		}

	/** To get the width. */
	public double getWidth()
		{return width*scale;}
	void setWidth(String v) {
		if(v != null)
			if((w = getDouble(v)) > 0)
				width = w;
		}
	private double w;

	/** To get the height. */
	public double getHeight()
		{return height*scale;}
	void setHeight(String v) {
		if(v != null)
			if((h = getDouble(v)) > 0)
				height = h;
		}
	private double h;


	/** To get the size. */
	public int getSize()
		{return size;}
	void setSize(int size) {
		if(size>0)
			this.size = size;
		}

	/** To get the background. */
	public String getGround() {
		if(ground != null)
			return new String(ground);
		return null;
		}
	void setGround(String v) {
		if(v!= null)
			ground = new String(v);
		}
	void setGround(String d,String f) {
		if((d!=null)&(f!= null))
			ground = new String(d+"/"+new File(f).getName());
		else if(f!=null)
			ground = new String(f);
		}

	/** Test if the map includes the parametter bounding box. */
	public boolean includes(ORectangle r) {
		if(r != null)
			if((r.getX0In()>=0)&(r.getY0In()>=0)&(r.getDX0In()<=width)&(r.getDY0In()<=height))
				return true;
		return false;
		}

	/** The print method. */
	public void print() {
		System.out.println	(
							"<map"
							+" scale=\""+scale+"\""
							+" width=\""+width+"\""
							+" height=\""+height+"\""
							+" size=\""+size+"\""
							+" ground=\""+ground+"\""
							+"/>\n"
							);
		}

	}

