package gggt.eg.set;

import java.io.*;

/**
* The Model class corresponds to a model tag
* into the setting file.
*/
class Models extends StringTo {

	private File db;						// the url of model database
	private String scale,wrap,resize,morph;	// the size attributes
	private String weight,constraints;		// the weight and constraint attributes

	/** Default constructor. */
	Models()
		{ db = null; scale = wrap = resize = morph = weight = constraints = null; }

	/** To load the model directory. */
	void loadUrl(String dir,String url) {
		if(dir!=null)
			loadUrl(dir);
		else
			loadUrl(url);
		}
	void loadUrl(String url) {
		if(url!=null) {
			if(new File(url).isDirectory())
				db = new File(url);
			}
		}

	/** To load the models */
	void loadModels(Setting set) {
		if((set!=null)&(db != null)&(mf != null)) {
			String[] fNames = db.list(mf); Model m;
			for(int i=0;i<fNames.length;i++) {
				m = new Model();
				m.loadUrl(db.getPath()+"/"+fNames[i]);
				if(scale!=null)
					m.setScale(scale);
				if(wrap!=null)
					m.setWrap(wrap);
				if(resize!=null)
					m.setResize(resize);
				if(morph!=null)
					m.setMorph(morph);
				if(weight!=null)
					m.setWeight(weight);
				if(constraints!=null)
					m.setConstraints(constraints);
				set.addModel(m);
				}
			}

		}
	private static ModelFilter mf = new ModelFilter();

	/** To set the scale attribute. */
	void setScale(String scale)
		{ if(scale != null) this.scale = new String(scale); }
	/** To set the wrap attribute. */
	void setWrap(String wrap)
		{ if(wrap != null) this.wrap = new String(wrap); }
	/** To set the resize attribute. */
	void setResize(String scale)
		{ if(resize != null) this.resize = new String(resize); }
	/** To set the morph attribute. */
	void setMorph(String morph)
		{ if(morph != null) this.morph = new String(morph); }
	/** To set the weight attribute. */
	void setWeight(String weight)
		{ if(weight != null) this.weight = new String(weight); }
	/** To set the constraints attribute. */
	void setConstraints(String constraints)
		{ if(constraints != null) this.constraints = new String(constraints); }

	/** Print method. */
	void print() {
		if(db!=null)
			System.out.println(	"<models"
								+" url=\""+db.getName()+"\""
								+" scale=\""+scale+"\""
								+" wrap=\""+wrap+"\""
								+" resize=\""+resize+"\""
								+" morph=\""+morph+"\""
								+" weight=\""+weight+"\""
								+" links=\""+constraints+"\""
								+"/>\n");
		}

	}

/** Model File filter. */
class ModelFilter implements  FilenameFilter {
    public boolean accept(File dir, String fileName) {
        if(fileName != null)
        	if(fileName.toLowerCase().endsWith(".gom")|fileName.toLowerCase().endsWith(".svg"))
            	return true;
        return false;
    	}
	}
